clear all
close all

a=0.0;
b=0.055;
c2=0.0;
d=0.055;

%LRlast=zeros(39,40);
%LRthis=zeros(39,40);
LRlast=zeros(39*4,40);
LRthis=zeros(39*4,40);

for ii=0:3
%nplus1=320;

%nplus1=40*2^ii;

nplus1=40;
%nplus1=80;
%nplus1=160;

n=nplus1-1;

%parameters

%diffcoe=8.5d-7;
diffcoe=8.5d-7;
vlb=1.0d-3;
vsb=0.08d0;
rkon=0.4d0;
rkoff=4.0d-6;
rkdeg=5.0d-4;
rjon=95.0;
rjoff=4.0d-6;
rjdeg=0.54;
%reph=9.0d0;
reph=3.0d0;
rep0=3.0d0;
xh=0.02;

h=(b-a)/(n+1);
c=diffcoe/h/h;    
X=zeros(n,n+1);
Y=zeros(n,n+1);
L=zeros(n,n+1);
LR=zeros(n,n+1);
LS=zeros(n,n+1);
S=zeros(n,n+1);

Rea1=zeros(n,n+1);
Rea2=zeros(n,n+1);
Rea3=zeros(n,n+1);
Rea4=zeros(n,n+1);

VL=zeros(n,n+1);
VS=zeros(n,n+1);
R=rep0*ones(n,n+1);

TermK1=zeros(n,n+1);
L2=zeros(n,n+1);
TermK2=zeros(n,n+1);
LR2=zeros(n,n+1);
TermK3=zeros(n,n+1);
LS2=zeros(n,n+1);
TermK4=zeros(n,n+1);
S2=zeros(n,n+1);

for i=1:n
    X(i,:)=i*h;
    if i*h <= xh
        R(i,:)=reph;
    end
end

for j=1:nplus1
    Y(:,j)=j*h;
    if j*h < 0.5*d
        VL(:,j)=vlb;
    else
        VS(:,j)=vsb;
    end
end

[L,LR,LS,S]=init(X,Y);

DA=zeros(n,n);
DB=zeros(nplus1,nplus1);

DA(1,1)=-2.0/3.0;
DA(1,2)=2.0/3.0;
DA(n,n-1)=2.0/3.0;
DA(n,n)=-2.0/3.0;
for k=2:n-1
    DA(k,k)=-2.0;
    DA(k,k-1)=1.0;
    DA(k,k+1)=1.0;
end
DA=c*DA;

DB(1,1)=-2.0;
DB(1,2)=1.0;
DB(1,nplus1)=1.0;
DB(nplus1,1)=1.0;
DB(nplus1,n)=1.0;
DB(nplus1,nplus1)=-2.0;
for k=2:n
    DB(k,k)=-2.0;
    DB(k,k-1)=1.0;
    DB(k,k+1)=1.0;
end
DB=c*DB;

ttt4=cputime;

dt=2*h/2.0^ii
EA=expm(dt*DA);
EB=expm(dt*DB);

tend=10.0d0;
tnum=0.0;
istop=0;

i88=0;
while istop==0
    if(tnum+dt > tend)
        dt=tend-tnum;
        EA=expm(dt*DA);
        EB=expm(dt*DB);
        istop=1;
    end
    
    Rea1=-rkon*L.*(R-LR)+rkoff*LR-rjon*L.*S+(rjoff+rjdeg)*LS+VL;
    Rea2=rkon*L.*(R-LR)-(rkoff+rkdeg)*LR;
    Rea3=rjon*L.*S-(rjoff+rjdeg)*LS;
    Rea4=-rjon*L.*S+rjoff*LS+VS;
    
    TermK1=EA*(L+(dt/2.0)*Rea1)*EB;
    TermK2=LR+(dt/2.0)*Rea2;
    TermK3=EA*(LS+(dt/2.0)*Rea3)*EB;
    TermK4=EA*(S+(dt/2.0)*Rea4)*EB;
    
    L2=TermK1+(dt/2.0)*Rea1;
    LR2=TermK2+(dt/2.0)*Rea2;
    LS2=TermK3+(dt/2.0)*Rea3;
    S2=TermK4+(dt/2.0)*Rea4;
    
%    while norm(U2-U,1)>1.0e-12
%    res=[max(max(L2-L)) max(max(LR2-LR)) max(max(LS2-LS)) max(max(S2-S))]; 
    res=[norm(L2-L,'fro')/n/(n+1) norm(LR2-LR,'fro')/n/(n+1) norm(LS2-LS,'fro')/n/(n+1) norm(S2-S,'fro')/n/(n+1)];
    iter=0;
%    while max(max(L2-L))>0 | max(max(LR2-LR))>0 | max(max(LS2-LS))>0 | max(max(S2-S))>0
    while max(res)>1.0e-13
        L=L2;
        LR=LR2;
        LS=LS2;
        S=S2;
        
        Rea1=-rkon*L.*(R-LR)+rkoff*LR-rjon*L.*S+(rjoff+rjdeg)*LS+VL;
        Rea2=rkon*L.*(R-LR)-(rkoff+rkdeg)*LR;
        Rea3=rjon*L.*S-(rjoff+rjdeg)*LS;
        Rea4=-rjon*L.*S+rjoff*LS+VS;
      
        L2=TermK1+(dt/2.0)*Rea1;
        LR2=TermK2+(dt/2.0)*Rea2;
        LS2=TermK3+(dt/2.0)*Rea3;
        S2=TermK4+(dt/2.0)*Rea4;
        
%        res=[max(max(L2-L)) max(max(LR2-LR)) max(max(LS2-LS)) max(max(S2-S))];
        iter=iter+1;
        res=[norm(L2-L,'fro')/n/(n+1) norm(LR2-LR,'fro')/n/(n+1) norm(LS2-LS,'fro')/n/(n+1) norm(S2-S,'fro')/n/(n+1)];
        if iter > 200
            res
            max(max(L2-L))
            max(max(LR2-LR))
            max(max(LS2-LS))
            max(max(S2-S))
            pause
        end
    end

    L=L2;
    LR=LR2;
    LS=LS2;
    S=S2;
     
    tnum=tnum+dt;
%    i88=i88+1;
%    if i88==100
%        tnum;
%        i88=0;
%    end
    
end

format long
cpu_time = cputime-ttt4


%for i=1:39        
%    for j=1:40
%        LRthis(i,j)=S(i*2^ii,j*2^ii);
%        LRthis(i,j)=S(i,j);
%    end
%end

LRthis=[L;LR;LS;S];

if ii > 0
    error=max(max(abs(LRthis-LRlast)))
    if ii > 1
        order=(log(error2)-log(error))/log(2.0)
    end
    error2=error;
end

LRlast=LRthis;

pause

end
    
            
surf(X,Y,LR)

    
